//+------------------------------------------------------------------+
//|                                         Freebie Signal Alert.mq4 |
//|                     Copyright  2010, Gorbushin Grigory (Dzhini) |
//|                                              grin2000@rbcmail.ru |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, Gorbushin Grigory (Dzhini)"
#property link      "grin2000@rbcmail.ru"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Chartreuse
#property indicator_color4 HotPink
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4

//----
extern color color1 = Lime;
extern color color2 = Red;
extern color color3 = Chartreuse;
extern color color4 = HotPink;
extern bool SoundON = false;
extern bool Filter  = false;
extern string FLTR  = "Filter hides bar if Stoch past 50";
extern bool OnClose = true;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double alertTag;


//----
int ExtCountedBars=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators

   SetIndexStyle(0, DRAW_HISTOGRAM, EMPTY,4, color1);
   SetIndexArrow(0, 233);
   SetIndexStyle(1, DRAW_HISTOGRAM, EMPTY,4, color2);
   SetIndexArrow(1, 234);
   SetIndexStyle(2, DRAW_HISTOGRAM, EMPTY,4, color3);
   SetIndexArrow(2, 233);
   SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY,4, color4);
   SetIndexArrow(3, 234);

//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);

   
//---- initialization done


   alertTag=Time[1];
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   double HAOpen, HAClose, HAOpenPrev, HAClosePrev,StochasticMain,StochasticSignal;

   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
   {

      if(!OnClose)
      {
         HAOpen=iCustom(Symbol(),0,"Heiken Ashi",2,pos);
         HAOpenPrev=iCustom(Symbol(),0,"Heiken Ashi",2,pos+1);
         HAClose=iCustom(Symbol(),0,"Heiken Ashi",3,pos);
         HAClosePrev=iCustom(Symbol(),0,"Heiken Ashi",3,pos+1);
          
         StochasticMain=iStochastic(Symbol(),0,10,3,3,0,0,0,pos);
         StochasticSignal=iStochastic(Symbol(),0,10,3,3,0,0,1,pos); 	   
   
         if (!Filter&&StochasticMain>StochasticSignal&&HAOpenPrev>HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer1[pos]=Low[pos]-10*Point;ExtMapBuffer2[pos]=0;}  
         if (!Filter&&StochasticMain<StochasticSignal&&HAOpenPrev<HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer2[pos]=High[pos]+10*Point;ExtMapBuffer1[pos]=0;}
         if (!Filter&&StochasticMain>StochasticSignal&&HAOpenPrev<HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer3[pos]=Low[pos]-10*Point;ExtMapBuffer4[pos]=0;}  
         if (!Filter&&StochasticMain<StochasticSignal&&HAOpenPrev>HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer4[pos]=High[pos]+10*Point;ExtMapBuffer3[pos]=0;}

         if (Filter&&StochasticMain>StochasticSignal&&StochasticSignal<50&&HAOpenPrev>HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer1[pos]=Low[pos]-10*Point;ExtMapBuffer2[pos]=0;}  
         if (Filter&&StochasticMain<StochasticSignal&&StochasticSignal>50&&HAOpenPrev<HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer2[pos]=High[pos]+10*Point;ExtMapBuffer1[pos]=0;}
         if (Filter&&StochasticMain>StochasticSignal&&StochasticSignal<50&&HAOpenPrev<HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer3[pos]=Low[pos]-10*Point;ExtMapBuffer4[pos]=0;}  
         if (Filter&&StochasticMain<StochasticSignal&&StochasticSignal>50&&HAOpenPrev>HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer4[pos]=High[pos]+10*Point;ExtMapBuffer3[pos]=0;}
 	   
         pos--;
 	   
         if (SoundON==true && pos==1 && (ExtMapBuffer1[pos] > ExtMapBuffer2[pos] || ExtMapBuffer3[pos] > ExtMapBuffer4[pos]) && alertTag!=Time[0])
         {
            Alert("Freebie Histo Alert (", Symbol(), ", ", Period(), ")--Possible BUY ");
//            PlaySound("Alert2.wav");
            alertTag = Time[0];
         }// End if (SoundON==true && pos==1 && (ExtMapBuffer1[pos] > 
         if (SoundON==true && pos==1 && (ExtMapBuffer2[pos] > ExtMapBuffer1[pos] || ExtMapBuffer4[pos] > ExtMapBuffer3[pos]) && alertTag!=Time[0])
         {
            Alert("Freebie Histo Alert (", Symbol(), ", ", Period(), ")--Possible SELL ");
//            PlaySound("Alert2.wav");
            alertTag = Time[0];
         }// End if (SoundON==true && pos==1 && (ExtMapBuffer2[pos] > 
      }// End if(!OnClose)
 	 
      if (OnClose)
      {
         HAOpen=iCustom(Symbol(),0,"Heiken Ashi",2,pos+1);
         HAOpenPrev=iCustom(Symbol(),0,"Heiken Ashi",2,pos+2);
         HAClose=iCustom(Symbol(),0,"Heiken Ashi",3,pos+1);
         HAClosePrev=iCustom(Symbol(),0,"Heiken Ashi",3,pos+2);
          
         StochasticMain=iStochastic(Symbol(),0,10,3,3,0,0,0,pos+1);
         StochasticSignal=iStochastic(Symbol(),0,10,3,3,0,0,1,pos+1); 	   
   
         if (!Filter&&StochasticMain>StochasticSignal&&HAOpenPrev>HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer1[pos+1]=Low[pos+1]-10*Point;ExtMapBuffer2[pos+1]=0;}  
         if (!Filter&&StochasticMain<StochasticSignal&&HAOpenPrev<HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer2[pos+1]=High[pos+1]+10*Point;ExtMapBuffer1[pos+1]=0;}
         if (!Filter&&StochasticMain>StochasticSignal&&HAOpenPrev<HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer3[pos+1]=Low[pos+1]-10*Point;ExtMapBuffer4[pos+1]=0;}  
         if (!Filter&&StochasticMain<StochasticSignal&&HAOpenPrev>HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer4[pos+1]=High[pos+1]+10*Point;ExtMapBuffer3[pos+1]=0;}

         if (Filter&&StochasticMain>StochasticSignal&&StochasticSignal<50&&HAOpenPrev>HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer1[pos+1]=Low[pos+1]-10*Point;ExtMapBuffer2[pos+1]=0;}  
         if (Filter&&StochasticMain<StochasticSignal&&StochasticSignal>50&&HAOpenPrev<HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer2[pos+1]=High[pos+1]+10*Point;ExtMapBuffer1[pos+1]=0;}
         if (Filter&&StochasticMain>StochasticSignal&&StochasticSignal<50&&HAOpenPrev<HAClosePrev&&HAOpen<HAClose) 
            {ExtMapBuffer3[pos+1]=Low[pos+1]-10*Point;ExtMapBuffer4[pos+1]=0;}  
         if (Filter&&StochasticMain<StochasticSignal&&StochasticSignal>50&&HAOpenPrev>HAClosePrev&&HAOpen>HAClose) 
            {ExtMapBuffer4[pos+1]=High[pos+1]+10*Point;ExtMapBuffer3[pos+1]=0;}
 	   
         pos--;
 	   
         if (SoundON==true && pos==1 && (ExtMapBuffer1[pos] > ExtMapBuffer2[pos] || ExtMapBuffer3[pos] > ExtMapBuffer4[pos]) && alertTag!=Time[0])
         {
            Alert("Freebie Histo Alert Confirmed (", Symbol(), ", ", Period(), ")-- BUY ");
            PlaySound("Alert2.wav");
            alertTag = Time[0];
         }// End if (SoundON==true && pos==1 && (ExtMapBuffer1[pos] > 
         if (SoundON==true && pos==1 && (ExtMapBuffer2[pos] > ExtMapBuffer1[pos] || ExtMapBuffer4[pos] > ExtMapBuffer3[pos]) && alertTag!=Time[0])
         {
            Alert("Freebie Histo Alert Confirmed (", Symbol(), ", ", Period(), ")-- SELL ");
            PlaySound("Alert2.wav");
            alertTag = Time[0];
         }// End if (SoundON==true && pos==1 && (ExtMapBuffer2[pos] >  
      }// End if (OnClose)
 	   
   }// End while(pos>=0)

//----
   return(0);
  }
//+------------------------------------------------------------------+






